# -*- coding: utf-8 -*-
"""
A single image without a pointing.
"""

from micado.main.DataExtensionImage import DataExtensionImage, persistent


class DataExtensionImageDetector(DataExtensionImage):
    """
    A single image without a pointing.
    """

    CTYPE1D = persistent("Pixel coordinate system [None]", str, 'LINEAR')
    CTYPE2D = persistent("Pixel coordinate system [None]", str, 'LINEAR')
    CUNIT1D = persistent("units of CRVAL1D and CDELT1D [None]", str, 'mm')
    CUNIT2D = persistent("units of CRVAL2D and CDELT2D [None]", str, 'mm')
    CDELT1D = persistent("coordinate increment [None]", float, 0.015)
    CDELT2D = persistent("coordinate increment [None]", float, 0.015)
    CRVAL1D = persistent("coordinate value at reference point [None]", float, 0.0)
    CRVAL2D = persistent("coordinate value at reference point [None]", float, 0.0)
    CRPIX1D = persistent("pixel coordinate of the reference point", float, 2048)
    CRPIX2D = persistent("pixel coordinate of the reference point", float, 2048)
