# -*- coding: utf-8 -*-
"""
CreateVarDqLayers
"""

import numpy

from micado.main.Img import Img
from micado.main.DataExtensionImage import (
    DataExtensionImage, DataExtensionVariance, DataExtensionQuality
)


def make(raw):
    """
    CreateVarDqLayers
    """
    extensions = [
        DataExtensionImage(
            NAXIS=rawextension.NAXIS,
            NAXIS1=rawextension.NAXIS1,
            NAXIS2=rawextension.NAXIS2,
            BITPIX=rawextension.BITPIX,
            data=rawextension.data,
        )
        for rawextension in raw.extensions
    ]
    variances = [
        DataExtensionVariance(
            NAXIS=rawextension.NAXIS,
            NAXIS1=rawextension.NAXIS1,
            NAXIS2=rawextension.NAXIS2,
            BITPIX=rawextension.BITPIX,
            data=rawextension.data,
        )
        for rawextension in raw.extensions
    ]
    qualities = [
        DataExtensionQuality(
            NAXIS=rawextension.NAXIS,
            NAXIS1=rawextension.NAXIS1,
            NAXIS2=rawextension.NAXIS2,
            BITPIX=rawextension.BITPIX,
            data=numpy.zeros(
                (rawextension.NAXIS1, rawextension.NAXIS2),
                dtype="int32",
            ),
        )
        for rawextension in raw.extensions
    ]

    img = Img()
    img.extensionn = extensions
    img.variances = variances
    img.qualities = qualities

    return img
