# -*- coding: utf-8 -*-
"""
Tests for finding MObjects.
"""

from common.database.Context import context
from common.database.DBSelect import Select
from micado.hardware.DarkCurrent import DarkCurrent


def test_dc():
    """
    Test MObject through DarkCurrent.
    """
    q: Select = DarkCurrent.select_all()
    ndarks = len(q)
    if ndarks:
        current = q.max('value#').value + 1
    else:
        current = 39

    dc0 = DarkCurrent(value=current, autocommit=False)
    assert len(q) == ndarks

    dc1 = DarkCurrent(value=current)
    assert len(q) == ndarks + 1

    dc2 = DarkCurrent(value=current)
    assert len(q) == ndarks + 1

    dc3 = DarkCurrent(object_id=dc1.object_id.binary())
    assert len(q) == ndarks + 1

    assert dc0 is not dc1
    assert dc3 is dc1
    assert dc1 is dc2

    # TODO: Apparently delete does not work
    context.delete(dc1, commit=True)
