# -*- coding: utf-8 -*-
"""
Tests for DataItem.py
"""

import hashlib
import os
import tempfile

from micado.main.DataItem import DataItem


def test_dataitem():
    """
    Test DataItem functions.
    """
    text = "helloworld".encode('utf-8')
    md5sum = hashlib.md5(text).hexdigest()
    fname_expected = f"DataItem_{md5sum}.txt"

    ftemp = tempfile.NamedTemporaryFile(suffix=".txt", delete=False)
    fname = ftemp.name
    ftemp.write(text)
    ftemp.close()

    di1 = DataItem()
    di1.unique_filename(fname)
    assert di1.filename == fname_expected

    di2 = DataItem()
    di2.filename = fname
    di2.unique_filename(fname)
    assert di2.filename == fname_expected

    os.unlink(fname)
