# -*- coding: utf-8 -*-
"""
Tests for ObservingBlock.py
"""

from collections import OrderedDict

from micado.main.ObservingBlock import ObservingBlock
from micado.templates.MCD_img_cal_dark import MCD_img_cal_dark


def test_ob_keywords():
    """
    Test whether keywords are properly done for OBs.
    """
    # A template
    dark_template1 = MCD_img_cal_dark(det__dit=1)
    # TODO: What about Observing Blocks with multiple Templates?
    #       Not supported for now.
    # dark_template2 = MCD_img_cal_dark(det1
    # An observingblock
    dark_ob = ObservingBlock(
        name="MyDarkTest",
        instrument="MICADO",
        target="empty_sky",
        templates=[dark_template1],
    )

    keywords_actual = dark_ob.fits_keywords

    keywords_desired = OrderedDict([
            ('FILENAME', ''),
            ('INSTRUME', 'MICADO'),
            ('NAME', 'MyDarkTest'),
            ('TARGET', 'empty_sky'),
        ] + [
            (f"HIERARCH ESO {k}", v)
            for k, v in [
                # TODO: Figure out if we can do something useful here..
                # ('DPR CATG', 'CALIB'),
                # ('TPL1 FILENAME', ''),
                # ('INS MODE', 'IMAGING'),
                # ('DET DIT', 1),
                # ('DET NDIT', 1),
                # ('DET READOUTMODE', 'CDS'),
                # ('DPR TECH', 'IMAGE'),
                # ('DPR TYPE', 'DARK'),
                # ('TPL1 CLS', 'MCD_img_cal_dark'),
            ]
        ])

    assert dict(keywords_actual) == dict(keywords_desired)
