# -*- coding: utf-8 -*-
"""
Tests for ditaa_from_wise.py
"""
# TODO: Create more unittest-like tests.

from micado.dataitems.Detrend import Detrend
from micado.toolbox.ditaa_from_wise import ditaa_from_wise

ditaa_expected = """
                    +--------------------+             
                    |                    |             
                    | MCD_img_sci_object |             
                    |cFFF                |             
                    +----------+---------+             
                               |                       
                            +-----+                    
                            |     |                    
                            |{o}  |                    
                            |cBLK |                    
                            +-----+                    
                               |                       
                               v                       
                         +---------+                   
                         |         |                   
                         | Science |                   
                         |c999     |                   
                         +-----+---+                   
                               |                       
                +-------------------------+            
                :McdImgDetrend |          |            
                |              v          |            
                |   /-------------------\\ |            
                |   |                   | |            
                |   | CreateVarDqLayers | |            
                |   |cB56               | |            
                |   \\----------+--------/ |            
                |              |          |            
+-------------+ |              |          |            
|             | |              |          |            
| Persistence +-|------------->|          |            
|c6CE         | |              |          |            
+-------------+ |              |          |            
                |              v          |            
                |    /------------------\\ |            
                |    |                  | |            
                |    | ApplyPersistence | |            
                |    |cB56              | |            
                |    \\---------+--------/ |            
                |              |          |            
+------------+  |              |          |            
|            |  |              |          |            
| MasterDark +--|------------->|          |            
|c47A        |  |              |          |            
+------------+  |              |          |            
                |              v          |            
                |    /-----------------\\  |            
                |    |                 |  |            
                |    | ApplyMasterDark |  |            
                |    |cB56             |  |            
                |    \\---------+-------/  |            
                |              |          |            
                +-------------------------+ +---------+
                               |            |         |
                               +----------->| Detrend |
                               |            |c283     |
                               v            +---------+
                            +-----+                    
                            |     |                    
                            |{o}  |                    
                            |cBLK |                    
                            +-----+                    
"""

# TODO: Put some of the below back in.
extra = """
                |              |          |            
+------------+  |              |          |            
|            |  |              |          |            
| MasterFlat +--|------------->|          |            
|c47A        |  |              |          |            
+------------+  |              |          |            
                |              v          |            
                |    /-----------------\\  |            
                |    |                 |  |            
                |    | ApplyMasterFlat |  |            
                |    |cB56             |  |            
                |    \\---------+-------/  |            
                |              |          |            
                |              v          |            
                |      /-------------\\    |            
                |      |             |    |            
                |      | SubtractSky |    |            
                |      |cB56         |    |            
                |      \\-------+-----/    |            
                |              |          |            
+-----------+   |              |          |            
|           |   |              |          |            
| IllumCorr +---|------------->|          |            
|c47A       |   |              |          |            
+-----------+   |              |          |            
                |              v          |            
                |     /----------------\\  |            
                |     |                |  |            
                |     | ApplyIllumCorr |  |            
                |     |cB56            |  |            
                |     \\--------+-------/  |            
"""


def test_detrend():
    ditaa_generated = str(ditaa_from_wise(Detrend))
    assert ditaa_expected.strip() == ditaa_generated.strip()
